Object subclass:#Java
	instanceVariableNames:''
	classVariableNames:'Classes UnresolvedClassRefs'
	poolDictionaries:''
	category:'Java-Support'
!


!Java class methodsFor:'accessing'!

allClasses
    ^ Classes
!

classNamed:aString
    ^ self at:aString
! !

!Java class methodsFor:'class initialization'!

initAllClasses
     self allClassesDo:[:cls |
        cls isInitialized ifFalse:[
            cls classInit
        ]
     ]

!

reinitAllClasses
     self markAllClassesUninitialized.
     self initAllClasses
! !

!Java class methodsFor:'enumerating'!

allClassesDo:aBlock
    Classes notNil ifTrue:[
        Classes do:aBlock
    ]
! !

!Java class methodsFor:'registering java classes'!

at:aJavaName
    "search & return for a class by name;
     if there is no such class, return nil.
     The argument, aJavaName may be either an internal name
     (sep'd by slashes) or an external name (sep'd by periods).
     The 'java/lang' standard packages prefix may be ommitted."

    |sym nm cls|

    Classes isNil ifTrue:[^ nil].

    sym := aJavaName asSymbolIfInterned.
    sym notNil ifTrue:[
        cls := Classes at:sym ifAbsent:nil.
        cls notNil ifTrue:[^ cls].
    ].

    nm := aJavaName.
    (nm includes:$.) ifTrue:[
        nm := (nm copy replaceAll:$. by:$/).
        sym := nm asSymbolIfInterned.
        sym notNil ifTrue:[
            cls := Classes at:sym ifAbsent:nil.
            cls notNil ifTrue:[^ cls].
        ].
    ].
        
    (nm includes:$/) ifFalse:[
        "/
        "/ try java.lang.Foo
        "/
        nm := 'java/lang/' , nm.
        sym := nm asSymbolIfInterned.
        sym notNil ifTrue:[
            cls := Classes at:sym ifAbsent:nil.
            cls notNil ifTrue:[^ cls].
        ].
    ].

    ^ nil

    "
     Java at:'java/lang/String' 
     Java at:'java.lang.String'
     Java at:'String'          
     Java at:'System'            
     Java at:'Foo'               
    "
!

at:aJavaName put:aJavaClass
    Classes isNil ifTrue:[
        Classes := IdentityDictionary new.
    ].
    Classes at:(aJavaName asSymbol) put:aJavaClass.

"/    UnresolvedClassRefs notNil ifTrue:[
"/        UnresolvedClassRefs do:[:toResolve |
"/        ]
"/    ].

    self changed:#classes

    "Created: 17.4.1996 / 23:29:31 / cg"
    "Modified: 18.4.1996 / 00:45:39 / cg"
!

flushClasses
    Classes := UnresolvedClassRefs := nil.

    "
     Java flushClasses
    "

    "Modified: 18.4.1996 / 00:20:23 / cg"
!

markAllClassesUninitialized
    self allClassesDo:[:aJavaClass |
        aJavaClass markUninitialized
    ].

    "
     Java markAllClassesUninitialized
    "
!

rememberUnresolved:anUnresolvedClassRef
"/    UnresolvedClassRefs isNil ifTrue:[
"/        UnresolvedClassRefs := OrderedCollection new.
"/    ].
"/    UnresolvedClassRefs add:anUnresolvedClassRef

    "Created: 18.4.1996 / 00:05:31 / cg"
    "Modified: 18.4.1996 / 00:05:41 / cg"
! !

!Java class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/Java.st,v 1.7 1996/05/06 09:01:54 cg Exp $'
! !
